<!--
IGAC proyecto SNC

@author fredy.wilches
@version 2.0
@description Formulario usado en ejecución para la creación o modificación de una unidad de construcción
@cu CU-CO-V-01

-->
<!--
IGAC proyecto SNC
@author pedro.garcia

D: NO funciona bien poner una condición de rendered para la forma, incluso si el valor del que
   depende sí se está asignando correctamente (en este caso, con un propertyActionListener en el botón
   que muestra el p:dialog que la contiene)
-->

<h:form xmlns="http://www.w3.org/1999/xhtml"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:p="http://primefaces.org/ui"
        xmlns:fn="http://java.sun.com/jsp/jstl/functions"
        id="detalleUnidadConstrForm" >

    <p:messages id="globalMessagesMCT" showDetail="false"
                globalOnly="false" autoUpdate="false" />


    <p:spacer height="30" width="1" />


    <p:fieldset  toggleable="true">

        <legend> 
            <h:outputText value="Descripción unidad de construcción"
                          styleClass="legendTitle" /> 
        </legend>

        <h:panelGrid columns="3" width="80%">
            <h:panelGroup>
                <h:outputLabel value="Unidad: " styleClass="outputLabelStyle" />
                <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                <h:inputText  required="true" requiredMessage="Debe ingresar el dato unidad"
                              value="#{managedBeanParam.unidadConstruccionSeleccionada.unidad}" 
                              />
            </h:panelGroup>

            <h:panelGroup>
                <h:outputLabel value="Uso unidad: " styleClass="outputLabelStyle" />
                <h:outputLabel value="*" styleClass="requiredLabelStyle" />
                <p:spacer width="5"/>
                <h:selectOneMenu id="usoUnidadCombo" label="Uso unidad"
                                 value="#{managedBeanParam.selectedUsoUnidadConstruccionId}"
                                 required="true">
                    <f:selectItems
                        value="#{managedBeanParam.usosUnidadConstruccionItemList}" />
                    <p:ajax
                        update="tipoCalificacion, panelConstrucciones, datosGeneralesUnidadConstruccion, usoUnidadCombo"
                        process="@this" onstart="statusDialog2.show()"
                        listener="#{managedBeanParam.actualizarArbolDeComponentes}"
                        oncomplete="statusDialog2.hide();">
                        <f:setPropertyActionListener target="#{managedBeanParam.unidadModeloConstruccionBool}"
                                                     value="false" />
                    </p:ajax>
                </h:selectOneMenu>
                <p:message for="usoUnidadCombo" display="icon"
                           id="reqUsoUnidadCombo" />
            </h:panelGroup>

            <h:panelGroup>
                <h:outputLabel value="Tipo de calificación: "
                               styleClass="outputLabelStyle" />
                <h:outputText id="tipoCalificacion"
                              value="#{managedBeanParam.selectedUsoUnidadConstruccion.destinoEconomico}"
                              styleClass="outputTextStyle" />
            </h:panelGroup>
        </h:panelGrid>

        <p:spacer height="10" width="1" />

        <p:outputPanel autoUpdate="false" id="panelConstrucciones" >
            <p:panel header="Construcción convencional"
                     id="constrConvencionalPanel"
                     rendered="#{managedBeanParam.selectedUsoUnidadConstruccion.destinoEconomico ne 'ANEXO'
                                 and managedBeanParam.selectedUsoUnidadConstruccionId != 0}">
                <p:treeTable 
                    value="#{managedBeanParam.treeComponentesConstruccion}"
                    var="calificacionConstruccionNode"
                    id="detalleCalificacionTree">
                    <p:column>
                        <f:facet name="header">
                            Componente construcción
                        </f:facet>
                        <h:outputText
                            value="#{calificacionConstruccionNode.calificacionConstruccion.componente}" />
                        <p:commandLink action="#{managedBeanParam.initCargarFoto}"
                                       oncomplete="gestionarFotografiasWV2.show();" 

                                       process="@this" update=":gestionFotosPG">
                            <p:effect type="puff" event="click" for="imgAnexoGI">
                                <p:graphicImage id="imgAnexoGI"
                                                value="#{calificacionConstruccionNode.urlArchivoWebTemporal}"
                                                width="32" height="24" style="text-align: right;"/>
                            </p:effect>
                            <f:setPropertyActionListener
                                target="#{managedBeanParam.currentCalificacionConstruccionNode}"
                                value="#{calificacionConstruccionNode}" />
                        </p:commandLink>					
                    </p:column>

                    <p:column>
                        <f:facet name="header">
                            Elemento calificación
                        </f:facet>
                        <h:outputText
                            value="#{calificacionConstruccionNode.calificacionConstruccion.elemento}" />
                    </p:column>
                    <p:column>
                        <f:facet name="header">
                            Detalle calificación
                        </f:facet>
                        <h:selectOneMenu
                            rendered="#{fn:length(calificacionConstruccionNode.detallesCalificacionItemList) gt 0}"
                            label="Detalle calificación" 
                            value="#{calificacionConstruccionNode.selectedDetalle}">
                            <f:selectItems
                                value="#{calificacionConstruccionNode.detallesCalificacionItemList}" />
                            <f:converter converterId="califConstrConverter" />
                            <p:ajax update="puntos, :detalleUnidadConstrForm:totalPuntos, :detalleUnidadConstrForm:tipificacion, 
                                    :detalleUnidadConstrForm:panelConstrucciones, :detalleUnidadConstrForm:globalMessagesMCT" 
                                    listener="#{managedBeanParam.validacionDetalleCalificacionConstruc}" />
                        </h:selectOneMenu>
                    </p:column>					

                    <p:column id="columnaPuntos">
                        <f:facet name="header">
                            Puntos
                        </f:facet>
                        <h:outputText
                            value="#{calificacionConstruccionNode.selectedDetalle.puntos}"
                            id="puntos" />
                    </p:column>				
                </p:treeTable>

                <p:spacer height="10" width="1" />

                <p:outputPanel layout="block" style="text-align:right">
                    <h:outputLabel value="Total puntaje antes de modificar: "
                                   styleClass="outputLabelStyle" />
                    <h:outputText
                        value="#{managedBeanParam.puntajeAnterior}"
                        styleClass="outputTextStyle" id="totalPuntosAntes" />
                </p:outputPanel>

                <p:outputPanel layout="block" style="text-align:right">
                    <h:outputLabel value="Total puntaje: "
                                   styleClass="outputLabelStyle" />
                    <h:outputText
                        value="#{managedBeanParam.totalPuntosConstruccion}"
                        styleClass="outputTextStyle" id="totalPuntos" />
                </p:outputPanel>


                <p:spacer height="10" width="1" />
                <p:outputPanel layout="block" style="text-align:right"
                               rendered="#{managedBeanParam.unidadConstruccionSeleccionada.tipoCalificacion == '1'}">
                    <h:outputLabel value="Tipificación: " styleClass="outputLabelStyle" />
                    <h:outputText
                        value="#{managedBeanParam.tipificacionUnidadConstruccion}"
                        styleClass="outputTextStyle" id="tipificacion" />
                </p:outputPanel>
            </p:panel>


            <p:panel header="Construcción no convencional"
                     id="constrNoConvencionalPanel"
                     rendered="#{managedBeanParam.selectedUsoUnidadConstruccion.destinoEconomico eq 'ANEXO'
                                 and managedBeanParam.selectedUsoUnidadConstruccionId != 0}">

                <p:dataTable value="">
                    <p:column>
                        <f:facet name="header">
                            Descripción construcción
                        </f:facet>

                        <h:selectOneMenu id="descripcionConstruccionCombo"

                                         value="#{managedBeanParam.selectedCalificacionAnexo}"
                                         label="Descripción construcción" required="true"
                                         style="width: 600px;">
                            <f:selectItems
                                value="#{managedBeanParam.descripcionConstruccionAnexoItemList}" />
                            <f:converter converterId="calificacionAnexoConverter" />
                            <p:ajax
                                update="tipoDescripcionConstruccion, :detalleUnidadConstrForm:globalMessagesMCT"
                                immediate="true" />
                        </h:selectOneMenu>                        
                    </p:column>

                    <p:column headerText="Tipo">
                        <h:outputText
                            value="#{managedBeanParam.tipoDescripcionConstruccion}"
                            styleClass="outputTextStyle" id="tipoDescripcionConstruccion" />                        
                    </p:column>

                    <p:column headerText="Dimensión">
                        <h:inputText
                            id="dimensionUC"
                            required="true"
                            requiredMessage="Ingrese un valor válido para la dimensión."
                            value="#{managedBeanParam.unidadConstruccionSeleccionada.areaConstruida}" label="Dimensión" title="Dimensión"
                            styleClass="outputTextStyle" 
                            maxlength="7">
                            <f:validateDoubleRange minimum="0.001" maximum="9999" />
                        </h:inputText>

                    </p:column>

                    <p:column headerText="Fotografía">
                        <p:commandLink action="#{managedBeanParam.initCargarFoto}"
                                       oncomplete="gestionarFotografiasWV2.show();" 
                                       value="fotos"
                                       process="@this, dimensionUC" update=":gestionFotosPG">
                            <p:effect type="puff" event="click" for="imgCAnexa">
                                <p:graphicImage id="imgCAnexa"
                                                value="#{managedBeanParam.rutaWebTemporalFotoAnexo}"
                                                width="32" height="24" style="text-align: right;" />
                            </p:effect>
                        </p:commandLink>
                    </p:column>

                </p:dataTable>

            </p:panel>
        </p:outputPanel>

        <p:spacer height="30" width="1" />

    </p:fieldset>

    <p:outputPanel autoUpdate="false" id="datosGeneralesUnidadConstruccion">
        <h:panelGrid columns="3" width="100%" rowClasses="columnOnTop"
                     rendered="#{managedBeanParam.selectedUsoUnidadConstruccion.destinoEconomico ne 'ANEXO'}">
            <h:column>
                <p:panel header="Datos generales unidad construcción">
                    <h:panelGrid rendered="#{!managedBeanParam.datosConstruccionSoloLectura}">
                        <h:outputLabel value="Nota:" styleClass="noteLabelStyle" />
                        <h:outputText
                            value="Recuerde que si algún valor tiene decimales, deben estar separados por coma."
                            styleClass="noteTextStyle" />
                    </h:panelGrid>

                    <p:separator style="width:270px;height:2px" />
                    <p:spacer height="5" width="0" />
                    <h:panelGrid columns="2">
                        <h:panelGroup>
                            <h:outputLabel value="Total pisos construcción: "
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle"
                                           rendered="#{!managedBeanParam.datosConstruccionSoloLectura}" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">
                            <h:inputText id="totalPisosConstr"
                                         label="Total pisos construcción"
                                         value="#{managedBeanParam.unidadConstruccionSeleccionada.totalPisosConstruccion}"
                                         maxlength="2" required="true">
                                <f:convertNumber pattern="##" maxIntegerDigits="2" type="number" />
                            </h:inputText>
                            <p:message for="totalPisosConstr" display="icon"
                                       id="reqTotalPisosConstr" />
                        </h:panelGrid>

                        <h:panelGroup>
                            <h:outputLabel value="Piso ubicación unidad: "
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle"
                                           rendered="#{!managedBeanParam.datosConstruccionSoloLectura}" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">
                            <h:selectOneMenu id="pisoUbicacionU" required="true"
                                             label="Piso ubicación unidad" style="width:120px"
                                             value="#{managedBeanParam.unidadConstruccionSeleccionada.pisoUbicacion}">
                                <f:selectItem itemValue="" itemLabel="Seleccionar..." />
                                <f:selectItems value="#{general.unidadPisoUbicacionV}" />
                            </h:selectOneMenu>
                            <p:message for="pisoUbicacionU" display="icon"
                                       id="reqPisoUbicacionU" />
                        </h:panelGrid>

                        <h:panelGroup>
                            <h:outputLabel value="Total pisos unidad: "
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle"
                                           rendered="#{!managedBeanParam.datosConstruccionSoloLectura}" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">
                            <h:inputText id="totalPisosU" label="Total pisos unidad"
                                         value="#{managedBeanParam.unidadConstruccionSeleccionada.totalPisosUnidad}"
                                         maxlength="2" required="true">
                                <f:convertNumber pattern="##" maxIntegerDigits="2" type="number" />
                                <f:validateLongRange minimum="1"></f:validateLongRange>
                            </h:inputText>
                            <p:message for="totalPisosU" display="icon" id="reqTotalPisosU" />
                        </h:panelGrid>

                        <h:panelGroup>
                            <h:outputLabel value="Total habitaciones: "
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle"
                                           rendered="#{!managedBeanParam.datosConstruccionSoloLectura}" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">
                            <h:inputText id="totalHabitacionesU" label="Total habitaciones"
                                         value="#{managedBeanParam.unidadConstruccionSeleccionada.totalHabitaciones}"
                                         maxlength="4" required="true">
                                <f:convertNumber pattern="####" maxIntegerDigits="4"
                                                 type="number" />
                            </h:inputText>
                            <p:message for="totalHabitacionesU" display="icon"
                                       id="reqTotalHabitacionesU" />
                        </h:panelGrid>

                        <h:panelGroup>
                            <h:outputLabel value="Total baños: "    
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle"
                                           rendered="#{!managedBeanParam.datosConstruccionSoloLectura}" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">
                            <h:inputText id="totalBaniosU" label="Total baños"
                                         value="#{managedBeanParam.unidadConstruccionSeleccionada.totalBanios}"
                                         maxlength="4" required="true">
                                <f:convertNumber pattern="####" maxIntegerDigits="4"
                                                 type="number" />
                            </h:inputText>
                            <p:message for="totalBaniosU" display="icon" id="reqTotalBaniosU" />
                        </h:panelGrid>

                        <h:panelGroup>
                            <h:outputLabel value="Total locales: "
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle"
                                           rendered="#{!managedBeanParam.datosConstruccionSoloLectura}" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">
                            <h:inputText id="totalLocalesU" label="Total locales"
                                         value="#{managedBeanParam.unidadConstruccionSeleccionada.totalLocales}"
                                         maxlength="4" required="true">
                                <f:convertNumber pattern="####" maxIntegerDigits="4"
                                                 type="number" />
                            </h:inputText>
                            <p:message for="totalLocalesU" display="icon"
                                       id="reqTotalLocalesU" />
                        </h:panelGrid>

                        <h:panelGroup>
                            <h:outputLabel value="Área unidad construida: "
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle"
                                           rendered="#{!managedBeanParam.datosConstruccionSoloLectura}" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">
                            <h:inputText id="areaConstruccionU" required="true" maxlength="7"
                                         label="Área unidad construida"
                                         value="#{managedBeanParam.unidadConstruccionSeleccionada.areaConstruida}">
                                <f:convertNumber maxIntegerDigits="7" type="number" locale="es"/>
                                <f:validateDoubleRange minimum="0.001"/>
                            </h:inputText>
                            <p:message for="areaConstruccionU" display="icon"
                                       id="reqAreaConstruccionU" />
                        </h:panelGrid>

                        <h:panelGroup>
                            <h:outputLabel value="Año de construcción: "
                                           styleClass="outputLabelStyle" />
                            <h:outputLabel value="*" styleClass="requiredLabelStyle"
                                           rendered="#{!managedBeanParam.datosConstruccionSoloLectura}" />
                        </h:panelGroup>
                        <h:panelGrid columns="2">
                            <h:inputText id="anioConstruccionU" label="Año de construcción"
                                         value="#{managedBeanParam.unidadConstruccionSeleccionada.anioConstruccion}"
                                         maxlength="4" required="true">
                                <f:convertNumber pattern="####" maxIntegerDigits="4"
                                                 type="number" />
                                <f:validateLongRange minimum="1" />
                            </h:inputText>
                            <p:message for="anioConstruccionU" display="icon"
                                       id="reqAnioConstruccionU" />

                        </h:panelGrid>

                    </h:panelGrid>
                </p:panel>
            </h:column>
            <h:column>
                <p:spacer width="10" height="1" />
            </h:column>
            <h:column>
                <h:panelGrid columns="1">
                    <h:outputLabel value="Observaciones: "
                                   styleClass="outputLabelStyle" />

                    <h:inputTextarea
                        label="Observaciones"
                        value="#{managedBeanParam.unidadConstruccionSeleccionada.observaciones}"
                        style="width:600px;height:100px;text-align:justify;top:0;position:static"
                        title="máximo 2000 caracteres">
                        <f:validateLength maximum="2000" />
                    </h:inputTextarea>
                    <p:spacer height="150" width="1" />
                </h:panelGrid>
            </h:column>
        </h:panelGrid>

    </p:outputPanel>

    <p:outputPanel layout="block" style="text-align:right">
        <p:commandButton value="Guardar cambios"

                         action="#{managedBeanParam.guardarDatosUnidadConstruccionYComponentes}"
                         title="Guardar los cambios a la unidad de construcción"
                         icon="ui-icon-disk"
                         update=":gestionarFichaMatrizForm, :detalleUnidadConstrForm, :gestionarFichaMatrizForm:panelAreasFM"
                         oncomplete="handleCompleteSIC(xhr, status, args, detalleUnidadConstruccionWV, false)" />

        <p:spacer height="1" width="10" />

        <p:commandButton value="Cerrar" title="Cierra esta ventana"
                         action="#{managedBeanParam.cerrarGestionDetallesUC}"
                         oncomplete="detalleUnidadConstruccionWV.hide()" icon="ui-icon-close" />
        <p:spacer height="1" width="20" />
    </p:outputPanel>

</h:form>